import React from 'react';
import { createSubscription } from 'create-subscription';
import { controllerPropType, childrenPropType } from './proptypes';
const ControllerSubscription = createSubscription({
  getCurrentValue: controller => controller.state,
  subscribe: (controller, callback) => {
    const subscription = controller.changes.subscribe(callback);
    return () => subscription.unsubscribe();
  }
});

const Subscription = (_ref) => {
  let source = _ref.source,
      children = _ref.children;
  return React.createElement(ControllerSubscription, {
    source: source
  }, state => children(state, source));
};

Subscription.propTypes = {
  source: controllerPropType,
  children: childrenPropType
};
export default Subscription;