import React from 'react';
import PropTypes from 'prop-types';
import { controllerPropType, childrenPropType } from './proptypes';
import Subscription from './Subscription';
import { share } from 'rinter';
const Context = React.createContext();
export const Provider = (_ref) => {
  let controller = _ref.controller,
      children = _ref.children;
  return React.createElement(Context.Provider, {
    value: share(controller)
  }, children);
};
Provider.propTypes = {
  controller: controllerPropType,
  children: PropTypes.node
};
export const Consumer = (_ref2) => {
  let children = _ref2.children;
  return React.createElement(Context.Consumer, null, controller => React.createElement(Subscription, {
    source: controller
  }, children));
};
Consumer.propTypes = {
  children: childrenPropType
};