"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _createSubscription = require("create-subscription");

var _proptypes = require("./proptypes");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const ControllerSubscription = (0, _createSubscription.createSubscription)({
  getCurrentValue: controller => controller.state,
  subscribe: (controller, callback) => {
    const subscription = controller.changes.subscribe(callback);
    return () => subscription.unsubscribe();
  }
});

const Subscription = (_ref) => {
  let source = _ref.source,
      children = _ref.children;
  return _react.default.createElement(ControllerSubscription, {
    source: source
  }, state => children(state, source));
};

Subscription.propTypes = {
  source: _proptypes.controllerPropType,
  children: _proptypes.childrenPropType
};
var _default = Subscription;
exports.default = _default;