"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Consumer = exports.Provider = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _proptypes = require("./proptypes");

var _Subscription = _interopRequireDefault(require("./Subscription"));

var _rinter = require("rinter");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const Context = _react.default.createContext();

const Provider = (_ref) => {
  let controller = _ref.controller,
      children = _ref.children;
  return _react.default.createElement(Context.Provider, {
    value: (0, _rinter.share)(controller)
  }, children);
};

exports.Provider = Provider;
Provider.propTypes = {
  controller: _proptypes.controllerPropType,
  children: _propTypes.default.node
};

const Consumer = (_ref2) => {
  let children = _ref2.children;
  return _react.default.createElement(Context.Consumer, null, controller => _react.default.createElement(_Subscription.default, {
    source: controller
  }, children));
};

exports.Consumer = Consumer;
Consumer.propTypes = {
  children: _proptypes.childrenPropType
};